## libpfm4 4.13.0+git83-g91970fe

=== debian/changelog ===
libpfm4 (4.13.0+git83-g91970fe-1) unstable; urgency=medium

  * New upstream GIT snapshot.
  * Bump Standards-Version to 4.7.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 18 Oct 2024 02:43:29 +0200
