## libpfm4 4.13.0+git99-gc5587f9

=== debian/changelog ===
libpfm4 (4.13.0+git99-gc5587f9-1) unstable; urgency=medium

  * New upstream GIT snapshot.
  * Refresh patches.
  * Simplify d/rules.
  * Bump Standards-Version to 4.7.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Mar 2025 12:55:34 +0100
