## libpfm4 4.13.0+git106

=== lib/Makefile ===
--- 
+++ 
@@ -130,6 +130,7 @@
 	  pfmlib_intel_spr_unc_imc.c \
 	  pfmlib_intel_spr_unc_upi.c \
 	  pfmlib_intel_spr_unc_cha.c \
+	  pfmlib_intel_gnr_unc_imc.c \
 	  pfmlib_intel_knc.c \
 	  pfmlib_intel_slm.c \
 	  pfmlib_intel_tmt.c \
@@ -383,11 +384,9 @@
 	events/intel_spr_unc_imc_events.h \
 	events/intel_spr_unc_upi_events.h \
 	events/intel_spr_unc_cha_events.h \
+	events/intel_gnr_unc_imc_events.h \
 	events/intel_slm_events.h
 
 INC_MIPS=events/mips_74k_events.h events/mips_74k_events.h
 
 INC_POWERPC=events/ppc970_events.h	\
-	events/ppc970mp_events.h	\
-	events/power4_events.h		\
-	events/power5_events.h		\
