## libpfm4 4.13.0+git106-g3e4031b

=== debian/changelog ===
libpfm4 (4.13.0+git106-g3e4031b-1) unstable; urgency=medium

  * New upstream GIT snapshot.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Aug 2025 14:28:55 +0200
