=== debian/rules ===
--- 
+++ 
@@ -29,10 +29,8 @@
 override_dh_auto_build:
 	dh_auto_build -- $(LIBPFM4_ARCH_FLAG)
 
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
 	./tests/validate
-endif
 
 override_dh_auto_install:
 	$(MAKE) install \
@@ -41,12 +39,3 @@
 		LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		LDCONFIG=true \
 		$(LIBPFM4_ARCH_FLAG)
-
-override_dh_missing:
-	dh_missing --list-missing
-
-override_dh_makeshlibs:
-	dh_makeshlibs -a -- -c4
-
-override_dh_shlibdeps:
-	dh_shlibdeps -a -- --warnings=7
