=== debian/watch ===
version=4

http://sf.net/perfmon2/libpfm-(4\..*)\.tar\.gz
